package info.bukova.isspst.services.users;

import java.util.HashSet;
import java.util.List;
import java.util.Set;

import org.hibernate.Query;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;

import info.bukova.isspst.data.Permission;
import info.bukova.isspst.data.Role;
import info.bukova.isspst.services.AbstractService;

public class RoleServiceImpl extends AbstractService<Role> implements RoleService {
	
	@Autowired
	private PermissionService permService;

	@Override
	@Transactional
	public Role getRoleByAuthority(String authority) {
		return this.selectSingle("from Role where authority = '" + authority + "'");
	}

	@Override
	@Transactional
	public List<Role> getWorkgroupRoles() {
		return this.execQuery("from Role where workgroup = true");
	}

	@Override
	@Transactional
	public List<Role> getCentreRoles() {
		return this.execQuery("from Role where centre = true");
	}

	@SuppressWarnings("unchecked")
	@Override
	@Transactional
	public List<Role> getRolesWithPermission(Permission perm, boolean centre) {
		String wgClausule;
		if (centre) {
			wgClausule = "centre";
		} else {
			wgClausule = "workgroup";
		}
		Set<Permission> perms = new HashSet<Permission>();
		perms.add(perm);
		Query q = dao.getQuery("select r from Role r join r.permissions p where r." + wgClausule + " = true and p in (:perms)");
		q.setParameterList("perms", perms);
		return q.list();
	}

	@Override
	@Transactional
	public List<Role> getRolesWithPermission(String authority, boolean centre) {
		Permission p = permService.selectSingle("from Permission where authority = '" + authority + "'"); 
		return getRolesWithPermission(p, centre);
	}

}
