package info.bukova.isspst.ui.settings;

import java.util.List;

import org.zkoss.bind.annotation.BindingParam;
import org.zkoss.bind.annotation.Command;
import org.zkoss.bind.annotation.Init;
import org.zkoss.bind.annotation.NotifyChange;
import org.zkoss.zk.ui.select.annotation.WireVariable;
import org.zkoss.zul.Window;

import info.bukova.isspst.data.Requirement;
import info.bukova.isspst.data.SettingsData;
import info.bukova.isspst.mail.MailMessage;
import info.bukova.isspst.services.settings.GlobalSettingsService;
import info.bukova.isspst.sort.ReflectionTools;
import info.bukova.isspst.ui.LocaleConverter;

public class GlobalSettingsVM {
	
	@WireVariable
	private GlobalSettingsService settingsService;
	private SettingsData settings;
	private LocaleConverter locConverter;
	
	@Init
	public void init() {
		settings = settingsService.getSettings();
		locConverter = new LocaleConverter();
	}

	public SettingsData getSettings() {
		return settings;
	}
	
	@Command
	public void save(@BindingParam("window") Window window) {
		settingsService.updateSettings();
		window.detach();
	}
	
	public List<String> getRequirementFields() {
		return ReflectionTools.getEntityFields(Requirement.class);
	}
	
	public boolean isCanSave() {
		return true;
	}

	public LocaleConverter getLocConverter() {
		return locConverter;
	}
	
	@Command
	@NotifyChange("settings")
	public void insertField(@BindingParam("field") String field, @BindingParam("message") MailMessage message) {
		message.setText(message.getText() + ":" + field + ":");
	}

}
